#ifndef _LIBDLD_COMMON_H_
#define _LIBDLD_COMMON_H_

#include <octave/oct.h>
#include <octave/byte-swap.h>

#include <sys/types.h>
#include <signal.h>

#include "accept_host.h"
#include "fifo_host.h"

class poctave_common{
 public:
  static bool poctave_is_active;
  static accept_host *host;
  static fifo_host *mpiproc;
  static pid_t mpi_pid;
};


bool
mpi_save_binary_data (std::ostream& os, const octave_value& tc,
		      const std::string& name, const std::string& doc,
		      bool mark_as_global, bool save_as_floats);
std::string
mpi_read_binary_data (std::istream& is, bool swap,
		      oct_mach_info::float_format fmt,
		      const std::string& filename, bool& global,
		      octave_value& tc, std::string& doc);


#endif
