#include"accept_host.h"

accept_host::accept_host(int o_serverport):Netbase(o_serverport){
  remotenum=1;
};

accept_host::accept_host(int o_serverport,int o_remotenum):Netbase(o_serverport){
  remotenum=o_remotenum;
};


int accept_host::servsocket(int default_portno)
{
  struct sockaddr_in my;
  int soc,opt;
  
  soc=socket(AF_INET,SOCK_STREAM,0);

  if( soc < 0 )
    {
      perror("socket");
      return -1;
    }
  
  opt = 1;
  
  if( setsockopt(soc,SOL_SOCKET,SO_REUSEADDR,(char *)&opt,sizeof(int)) !=0 )
    {
      perror("setsockopt");
      socketclose(soc);
    }
  
  memset((char *)&my,0,sizeof(my));
  my.sin_family = AF_INET;
  my.sin_port=htons(default_portno);
  my.sin_addr.s_addr = INADDR_ANY ;

  if( bind(soc,(struct sockaddr *)&my,sizeof(my)) == -1 )
    {
      perror("bind");
      socketclose(soc);
      return -1;
    }

  if( listen(soc,SOMAXCONN) == -1 )
    {
      perror("listen");
      socketclose(soc);
      return -1;
    }

  return soc;
};

bool accept_host::start(void){
  
  listensock=servsocket(portnumber);
  if( listensock < 0){
    perror("ERR accept_host::start");
    return false;
  }

  for(int i=0;i< remotenum; i++){
    host *h=new host();
    struct sockaddr_in addr;
    socklen_t addrlen=sizeof(addr);  
    h->fdw=accept(listensock,(struct sockaddr *)&addr,&addrlen);
    h->fdr=h->fdw;
    if(h->fdw==-1){
      perror("accetp_host::start");
      return false;
    }

    /* Exchange Process id */
    pid_t remote_pid;
    pid_t my_pid;
    my_pid = getpid();
    sendsize(h->fdr,(char *)&my_pid,sizeof(pid_t));
    recvsize(h->fdw,(char *)&remote_pid,sizeof(pid_t));
    h->pid = remote_pid;
    h->hostname = getnamebyfd(h->fdw);
    connectedhost(h);
  }

};

bool accept_host::stop(void){
  Netbase::stop();
  close(listensock);
  return true;
};

accept_host::~accept_host(void){
  accept_host::stop();
};




