#include"connect_host.h"

int connect_host::clientsocket(const char *host,int default_portno)
{
  struct sockaddr_in server;
  struct in_addr addr;
  int soc;
  soc = socket(AF_INET,SOCK_STREAM,0);

  if( soc < 0 )
    {
      perror("socket");
      return -1;
    }

  if( atoaddr(host,&addr) == 0 )
    {
      socketclose(soc);
      return -1;
    }

  memset((char *)&server,0,sizeof(server));

  server.sin_family = AF_INET;
  server.sin_port = htons(default_portno);
  server.sin_addr = addr;
  
 label:
  if( connect(soc,(struct sockaddr *)&server,sizeof(server)) == -1 )
    {
      if( errno == ECONNREFUSED )
	{
	  /* Until connection is establishable,loop continue */
	  errno=0;
	  sleep(1);
	  goto label;
	}
    }
  
  return soc;
};

bool connect_host::start(void){
  host *h=new host();
  
  h->hostname = target_hostname;
  in_addr hostaddr;
  atoaddr(target_hostname.c_str() ,&hostaddr);

  h->fdw = clientsocket(inet_ntoa(hostaddr),portnumber);
  h->fdr = h->fdw;

  if(h->fdw==-1){
    perror("connect_host::start");
    return false;
  }
  
  /* Exchange Process id */
  pid_t remote_pid;
  pid_t my_pid;
  my_pid = getpid();
  sendsize(h->fdr,(char *)&my_pid,sizeof(pid_t));
  recvsize(h->fdw,(char *)&remote_pid,sizeof(pid_t));
  h->pid=remote_pid;
  h->hostname = getnamebyfd(h->fdw);
  connectedhost(h);

  return true;
};

connect_host::connect_host(std::string &th,
			   int o_portnumber) : Netbase(o_portnumber)
{
  target_hostname = th;
};

connect_host::~connect_host(void){
  Netbase::stop();
};






