#include"fifo_host.h"

bool fifo_host::createfifo(std::string fifopath){
  if(access(fifopath.c_str(),F_OK)==-1){
    if(mkfifo(fifopath.c_str(),0700)!=0){
      perror("fifo_host::createfifo");
      fprintf(stderr,"pid =%d ,path=%s\n",getpid(),fifopath.c_str());
      return false;
    }
  }
  return true;
};

bool fifo_host::start(void){
  host *h=new host();

  if(firstconnect==1){
    h->fdw=open(fifopath1.c_str(),O_WRONLY);
    h->fdr=open(fifopath2.c_str(),O_RDONLY);
  }
  else if(firstconnect==2){
    h->fdr=open(fifopath2.c_str(),O_RDONLY);
    h->fdw=open(fifopath1.c_str(),O_WRONLY);
  }
  else{
    return false;
  };

  if((h->fdw==-1)||(h->fdr==-1)){
    perror("fifo_host::start");
    return false;
  }
  char hostname[512];
  gethostname(hostname,sizeof(hostname));
  h->hostname=hostname;
  connectedhost(h);

  return true;
};

fifo_host::fifo_host(std::string o_fifopath1,std::string o_fifopath2,
		     int o_firstconnect):Netbase(0){
  fifopath1=o_fifopath1;
  fifopath2=o_fifopath2;
  
  createfifo(o_fifopath1);
  createfifo(o_fifopath2);
    
  firstconnect=o_firstconnect;
};

fifo_host::~fifo_host(void){
  Netbase::stop();
};

bool fifo_host::removefifo(void){
  remove(fifopath1.c_str());
  remove(fifopath2.c_str());
  return true;
};



