#ifndef _POCTAVE_DIRSETTING_
#define _POCTAVE_DIRSETTING_

#include <iostream>
#include <vector>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <fcntl.h>
#include <assert.h>

using namespace std;

extern char **environ;

class Fileplace{
 public:
  static string getpath(void);
  static bool   set_prefix(std::string);
 private:

  Fileplace(std::string prefix){

    if(search_environ("HOME"))
      path=get_environ("HOME");
    else if(search_environ("POCTAVE_HOME"))
      path=get_environ("POCTAVE_HOME");
    else
      path=string("/tmp");

    common_dirname=string(".poctave");

    char hostname[512];
    gethostname(hostname,sizeof(hostname));
    individual_dirname=std::string(hostname)+prefix;
    
    if(createdir(path+common_dirname)==false){
      switch(errno){
      case EEXIST:
	/*
	 * When using NFS,other process create some name directory;
	 */
	errno=0;
	break;
      default:
	assert(false);
      }
    }

    if(createdir(path+common_dirname+
		 string("/")+individual_dirname)==false){
      switch(errno){
      case EEXIST:
	/*
	 * When using NFS,other process create some name directory;
	 */
	errno=0;
	break;
      default:
	assert(false);
      }
    }

  };

  ~Fileplace(void){};
  
  string get_environ(string);
  bool search_environ(string);
  bool createdir(string);

  static Fileplace *instance;
  string path;
  string common_dirname;
  string individual_dirname;
};

#endif






