#ifndef _NETBASE_H_
#define _NETBASE_H_

#include <string>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <grp.h>
#include <assert.h>
#include <poll.h>
#include <sys/wait.h>
#include <netinet/in.h>

class Netbase{
 public:
  Netbase(int);
  virtual ~Netbase(void);
  virtual bool start(void)=0;
  bool stop(void);

  bool send(const void *,int);
  int recv(const void *,int);

  int scan_any_stream(std::string &,pid_t &,int);
  
 protected:
  int socketclose(int);
  int recvsize(int,char *,int);
  int sendsize(int,char *,int);
  int atoaddr(const char *,struct in_addr *);

  typedef struct host{
    std::string hostname; //another hostname
    pid_t pid;
    int fdw; //The file descriptor for writing in towards another host
    int fdr; //The file descriptor for reading in towards another host
  };

  bool connectedhost(host *);

  const int portnumber;

  bool sendhost(std::string,pid_t,const void *,int); 
  int recvhost(std::string,pid_t,const void *,int);

  char *getnamebyfd(int);
  
 private:
  std::vector<host *> hostlist;
  int atoport(const char *,char *);
};

#endif

