#ifndef _PO_PROCESS_INFO_H_
#define _PO_PROCESS_INFO_H_

typedef struct _mpi_process_info{
  std::string hostname;
  int mpi_rank;
  pid_t mpi_pid;
} mpi_process_info;

typedef struct _octave_process_info{
  std::string hostname;
  pid_t pid;
} octave_process_info;

typedef struct _node_process_info{
  std::string hostname;
  pid_t octave_pid;
  pid_t mpi_pid;
  int mpi_rank;
  int wrapper_local_to_remote_pid;
  int wrapper_remote_to_local_pid;
  
} node_process_info;

#include <vector>

/*
 * This class offers storing of the information about a process.
 * this class is written as Singleton Class.
 */

template <class IT>
class
process_info
{
  
 public:
  static std::vector<IT> *instance(void){
    
    /*
     * This code will become a problem when multi-thread programing.
     * I assume that multi-thread programing is not used.
     */
    
    static std::vector<IT> _vector;
    return &_vector;
  };

  typedef typename std::vector<IT>::iterator iterator;

  typedef typename std::vector<IT>::const_iterator const_iterator;

 protected:

  // No instance!

  process_info(void){};
  
  // Need destractor?
  virtual ~process_info(void){};
  
  // No copying!
    
  process_info(const process_info&){};
  
  process_info& operator = (const process_info&){};

};

#endif







