#/bin/sh

OCTAVE_MPI_HEADER_NAME=octave_mpi_functions.h

function add_init(){
    rm $OCTAVE_MPI_HEADER_NAME
    echo "
#ifndef _OCTAVE_MPI_HEADER_
#define _OCTAVE_MPI_HEADER_

#include \"oh.h\"
#include \"global.h\"

" >>$OCTAVE_MPI_HEADER_NAME

}

function add_func(){

    echo "
class Function_$1:public Function{
public: 
    Function_$1(void){name=std::string(\"$1\");}; 
    std::string do_op(void);
    virtual ~Function_$1(void){};
};" >>$OCTAVE_MPI_HEADER_NAME

}

function add_end(){
    echo "#endif" >>$OCTAVE_MPI_HEADER_NAME
}

#start point
FILES=`find -name "octave_*.cc"`

add_init

for FILE in $FILES ; do
    echo INFO create $FILE header
    FUNC_NAME=`echo $FILE | sed 's/\(\.\/octave_\)//' |sed 's/...$//'`
    add_func $FUNC_NAME
done

add_end
