#include "octave_mpi_functions.h"

std::string Function_mpi_bcast::do_op(void){
  int size;
  char *buff;
  int ope_type; // recv 0 when send,else recv -1;
  int root;
  int key;
  int retval=0;

  octaveproc->recv(&ope_type,sizeof(int));
  octaveproc->recv(&root,sizeof(int)); 
  octaveproc->recv(&size,sizeof(int));

  if( ope_type == 0 ){ //Send operation
    //Create buffer and Recv binary octave_value
    int buff_length;
    octaveproc->recv(&buff_length,sizeof(int));
    buff=new char[buff_length];
    assert(buff!=NULL);
    octaveproc->recv(buff,buff_length);
  }
  else{ //Recv operation
    //Just Create buffer;
    buff = new char[size];
  }

  octaveproc->recv(&key,sizeof(int));

  data_conv_map<int,MPI_Comm>::iterator it;
  MPI_Comm comm;
  it=map_mpi_comm.find(key);
  if(it==map_mpi_comm.end()){
    MPI_Comm *comm_p;
    comm_p=new MPI_Comm;
    map_mpi_comm.insert(std::make_pair(key,*comm_p));
    comm=*comm_p;
  }
  else{
    comm=it->second;
  }

//    int MPI_Bcast(void *buff, int count, MPI_Datatype datatype,
//  		int root, MPI_Comm comm)
  
  MPI_Bcast(buff,size,MPI_BYTE,root,comm);

  if( ope_type == 0 ){ //Send operation
    octaveproc->send(&retval,sizeof(int));
  }
  else{ //Recv operation
    octaveproc->send(&size,sizeof(int));
    octaveproc->send(buff,size);
  }

  delete buff;
  return string("octave_mpi_bcast finish");
};

