#include "octave_mpi_functions.h"

std::string Function_mpi_irecv::do_op(void){
  int size;
  int src;
  int tag;
  int key;

  int req_key;

  octaveproc->recv(&size,sizeof(int));
  octaveproc->recv(&src,sizeof(int));
  octaveproc->recv(&tag,sizeof(int));
  octaveproc->recv(&key,sizeof(int));

  data_conv_map<int,MPI_Comm>::iterator it;
  MPI_Comm comm;
  it=map_mpi_comm.find(key);
  if(it==map_mpi_comm.end()){
    MPI_Comm *comm_p;
    comm_p=new MPI_Comm;
    map_mpi_comm.insert(std::make_pair(key,*comm_p));
    comm=*comm_p;
  }
  else{
    comm=it->second;
  }

  int buffer_length=size;
  req_bin *rb = new req_bin(buffer_length);

  //Find new key which accompanies new MPI_Request

  //NEEDFIX 
  //too poor implementation
  for(req_key=0;req_key<100;req_key++){
    data_conv_map<int,req_bin *>::iterator itt;
    itt=map_mpi_request.find(req_key);
    if(itt == map_mpi_request.end() ) //Find empty space;
      break;
  }

  if( req_key==100){
    assert(false);
    //Can't allocate MPI_Request. Send error
    octaveproc->send(&req_key,sizeof(int));
    return std::string("Request alloc failure. octave_mpi_irecv finish");
  }
  else
    map_mpi_request.insert(make_pair(req_key,rb)); //insert Request
  
//    int MPI_Irecv(void *buf, int count, MPI_Datatype dtype,
//  		int src, int tag, MPI_Comm comm,
//  		MPI_Request *req)

  MPI_Irecv(rb->binary,rb->binary_size,MPI_BYTE,src,tag,comm,&rb->request);

  octaveproc->send(&req_key,sizeof(int));

  return std::string("octave_mpi_irecv finish");
}

