#include "octave_mpi_functions.h"

string Function_mpi_recv::do_op(void){
  int size;
  int src;
  int tag;
  int key;
  
  octaveproc->recv(&size,sizeof(int));
  octaveproc->recv(&src,sizeof(int));
  octaveproc->recv(&tag,sizeof(int));
  octaveproc->recv(&key,sizeof(int));

  data_conv_map<int,MPI_Comm>::iterator it;
  MPI_Comm comm;
  it=map_mpi_comm.find(key);
  if(it==map_mpi_comm.end()){
    MPI_Comm *comm_p;
    comm_p=new MPI_Comm;
    map_mpi_comm.insert(std::make_pair(key,*comm_p));
    comm=*comm_p;
  }
  else{
    comm=it->second;
  }

  /*
   *   int MPI_Recv(void *buf, int count, MPI_Datatype dtype,
   *         int src, int tag, MPI_Comm comm, MPI_Status *stat)
   */

  MPI_Status stat;
  int buffer_length=size;
  char buffer_data[buffer_length];
  MPI_Recv(buffer_data,size,MPI_BYTE,src,tag,comm,&stat);

  octaveproc->send(&buffer_length,sizeof(int));
  octaveproc->send(buffer_data,buffer_length);

  return string("octave_mpi_recv finish");
};
  
