#include "octave_mpi_functions.h"

string Function_mpi_send::do_op(void){
  int size;
  char *buff;
  int dest;
  int tag;
  int key;

  octaveproc->recv(&size,sizeof(int));

  int buff_length;
  octaveproc->recv(&buff_length,sizeof(int));
  buff=new char[buff_length];
  assert(buff!=NULL);
  octaveproc->recv(buff,buff_length);

  octaveproc->recv(&dest,sizeof(int));
  octaveproc->recv(&tag,sizeof(int));
  octaveproc->recv(&key,sizeof(int));

  data_conv_map<int,MPI_Comm>::iterator it;
  MPI_Comm comm;
  it=map_mpi_comm.find(key);
  if(it==map_mpi_comm.end()){
    MPI_Comm *comm_p;
    comm_p=new MPI_Comm;
    map_mpi_comm.insert(std::make_pair(key,*comm_p));
    comm=*comm_p;
  }
  else{
    comm=it->second;
  }

  /*
   *  int MPI_Send(void *buf, int count, MPI_Datatype dtype, int dest,
   *               int tag, MPI_Comm comm)
   */
  int retval=MPI_Send(buff,size,MPI_BYTE,dest,tag,comm);

  delete buff;
  octaveproc->send(&retval,sizeof(int));
  return string("octave_mpi_send finish");
};
  


