#include "octave_mpi_functions.h"

std::string Function_mpi_testall::do_op(void){
  int col;

  int mpi_retval; //SUCCESS:0,FAILURE=-1
  octaveproc->recv(&col,sizeof(int));
  assert(col>0);
  //fprintf(stderr,"col=%d\n",col);
  int key[col];
  MPI_Request reqs[col];
  for(int i=0;i<col;i++){
    octaveproc->recv(&key[i],sizeof(int));
  }

  data_conv_map<int,req_bin *>::iterator it;  

  //Check request exist in map_mpi_request
  for(int reqs_index=0;reqs_index<col;reqs_index++){
    //fprintf(stderr,":req=%d\n",key[reqs_index]);
    it=map_mpi_request.find(key[reqs_index]);
    if(it==map_mpi_request.end()){
      //if There is no MPI_Request, Nothing called
      mpi_retval=-1;
      octaveproc->send(&mpi_retval,sizeof(int));
      return std::string("mpi_testany finish");
    }
    //We assume MPI_Request can copy;
    reqs[reqs_index]=it->second->request;
  }

//    int MPI_Testany(int count, MPI_Request *reqs,
//  		  int *index, int *flag, MPI_Status *stat)
		  
  MPI_Status stat;
  int flag;

  assert(MPI_SUCCESS==MPI_Testall(col,reqs,&flag,&stat));

  //fprintf(stderr,"flag=%d\n",flag);
  if( flag ){
    //MPI_I*** Operation is completed
    mpi_retval=1;
    octaveproc->send(&mpi_retval,sizeof(int));

    //Erase MPI_Request 
    //If calling MPI_Testany twice for MPI_Request, 
    //which already called previouse MPI_Testany and
    //confirmed it's operation completion,
    //MPI process caught a SIGSEGV error.

    data_conv_map<int,req_bin *>::iterator it;  

    for(int reqs_index=0;reqs_index<col;reqs_index++){
      //fprintf(stderr,":req=%d\n",key[reqs_index]);
      it=map_mpi_request.find(key[reqs_index]);

      octaveproc->send(&it->second->binary_size,sizeof(int));
      octaveproc->send(it->second->binary,it->second->binary_size);

      //delete MPI_Request
      delete it->second;
      map_mpi_request.erase(key[reqs_index]);
    }


    return std::string("mpi_testall finish");
  }

  mpi_retval=-2;
  octaveproc->send(&mpi_retval,sizeof(int));

  return std::string("mpi_testany finish");
};
