#include "octave_mpi_functions.h"

std::string Function_mpi_wait::do_op(void){
  int key;

  int retval; //SUCCESS:0,FAILURE=-1

  octaveproc->recv(&key,sizeof(int));

  data_conv_map<int,req_bin *>::iterator it;
  it=map_mpi_request.find(key);
  if(it==map_mpi_request.end()){
    //if There is no MPI_Request, Nothing called
    retval=-1;
    octaveproc->send(&retval,sizeof(int));

    return std::string("mpi_wait finish");
  }

  MPI_Status stat;
  MPI_Wait(& (it->second->request),&stat);

  retval=0;
  octaveproc->send(&retval,sizeof(int));

  octaveproc->send(&it->second->binary_size,sizeof(int));
  octaveproc->send(it->second->binary,it->second->binary_size);

  //Delete bin_req from map
  delete it->second;
  map_mpi_request.erase(key);

  return std::string("mpi_wait finish");
};


