#include "octave_mpi_functions.h"

std::string Function_mpi_waitany::do_op(void){
  int col;
  int index;

  int mpi_retval; //SUCCESS:0,FAILURE=-1
  octaveproc->recv(&col,sizeof(int));
  assert(col>0);
  //fprintf(stderr,"col=%d\n",col);
  int key[col];
  MPI_Request reqs[col];
  for(int i=0;i<col;i++){
    octaveproc->recv(&key[i],sizeof(int));
  }

  data_conv_map<int,req_bin *>::iterator it;

  //Check request exist in map_mpi_request
  for(int reqs_index=0;reqs_index<col;reqs_index++){
    //fprintf(stderr,":req=%d\n",key[reqs_index]);
    it=map_mpi_request.find(key[reqs_index]);
    if(it==map_mpi_request.end()){
      //if There is no MPI_Request, Nothing called
      mpi_retval=-1;
      index=-2;
      octaveproc->send(&mpi_retval,sizeof(int));
      octaveproc->send(&index,sizeof(int));
      return std::string("mpi_testany finish");
    }
    //We assume MPI_Request can copy;
    reqs[reqs_index]=it->second->request;
  }

//    int MPI_Waitany(int count, MPI_Request *reqs, int *index,
//        MPI_Status *stat)

  MPI_Status stat;

  assert(MPI_SUCCESS==MPI_Waitany(col,reqs,&index,&stat));

  //fprintf(stderr,"flag=%d\n",flag);

  if( index != MPI_UNDEFINED ){
    //MPI_I*** Operation is completed
    mpi_retval=1;
    octaveproc->send(&mpi_retval,sizeof(int));
    octaveproc->send(&index,sizeof(int));

    //Erase MPI_Request
    //If calling MPI_Testany twice for MPI_Request,
    //which already called previouse MPI_Testany and
    //confirmed it's operation completion,
    //MPI process caught a SIGSEGV error.

    data_conv_map<int,req_bin *>::iterator it;
    it=map_mpi_request.find(key[index]);

    octaveproc->send(&it->second->binary_size,sizeof(int));
    octaveproc->send(it->second->binary,it->second->binary_size);

    delete it->second;
    map_mpi_request.erase(key[index]);

    return std::string("mpi_waitany finish");
  }

  assert(index==MPI_UNDEFINED);

  mpi_retval=-2;
  index=-2;
  octaveproc->send(&mpi_retval,sizeof(int));
  octaveproc->send(&index,sizeof(int));

  return std::string("mpi_waitany finish");
};

