#ifndef _DATA_CONV_MAP_H_
#define _DATA_CONV_MAP_H_

//hash table
#include <map>

template<typename key,typename value>
class data_conv_map{

 public:
  typedef typename std::map<key,value>::iterator iterator;
  typedef typename std::map<key,value>::const_iterator const_iterator;
  
  std::pair<iterator,bool> insert(const std::pair<key,value> &pr){
    return mp.insert(pr);
  };
  
  iterator find(const key &k) {
    return mp.find(k);
  };
  
  const_iterator find(const key& k) const{
    return mp.find(k);
  };
  
  void erase(iterator it){
    mp.erase(it);
  };

  void erase(const key &k){
    mp.erase(k);
  };

  iterator begin(void){
    return mp.begin();
  };

  iterator end(void){
    return mp.end();
  };

 private:
  std::map<key,value> mp;

};

#endif
