#ifndef _GLOBAL_VARIABLE_H_
#define _GLOBAL_VARIABLE_H_

#include <mpi.h>
#include "data_conv_map.h"

//Can MPI_*** (c.f MPI_Comm,MPI_Request) store in std::map ??
//LAM/MPI can store. But it's not sure other MPI-library allow this.

//For MPI_*** functions which use Communicator
extern data_conv_map<int,MPI_Comm> map_mpi_comm;

//bind MPI_Request and binary data
struct req_bin{
  MPI_Request request;
  char *binary;
  int binary_size;

  req_bin(int size):binary_size(size){
    binary=new char[binary_size];
  };
  
  ~req_bin(void){
    if(binary!=NULL){
      delete binary;
    }
    binary=NULL;
  };

};

//For MPI_i*** functions which behave as non-blocking
extern data_conv_map<int,req_bin *>   map_mpi_request;

#endif
