mpi_init(1);

tag=0;
dest=0;
src=0;

#NEEDFIX
#this_value_must_be_defined_in_mpi_init()
MPI_COMM_WORLD=0;
tmp1=rand(25,1024);

###################
#mpi_send,mpi_recv#
###################
mpi_send(sizeof(tmp1),sizeof,dest,tag,MPI_COMM_WORLD);
mpi_send(tmp1,sizeof(tmp1),dest,tag,MPI_COMM_WORLD);

recv_size=mpi_recv(sizeof,src,tag,MPI_COMM_WORLD);
tmp2     =mpi_recv(recv_size,src,tag,MPI_COMM_WORLD);

assert(tmp1 == tmp2);
fprintf(stderr,"mpi_send,mpi_recv\t\t:pass check\n");

#############################
#mpi_irecv,mpi_test,mpi_wait#
#############################
req1=mpi_irecv(sizeof,src,tag,MPI_COMM_WORLD);
assert(mpi_test(req1)==0);
mpi_send(sizeof(tmp1),sizeof,dest,tag,MPI_COMM_WORLD);
assert(mpi_test(req1)==1);
recv_size=mpi_wait(req1);

req2=mpi_irecv(recv_size,src,tag,MPI_COMM_WORLD);
assert(mpi_test(req2)==0);
mpi_send(tmp1,sizeof(tmp1),dest,tag,MPI_COMM_WORLD);
assert(mpi_test(req2)==1);
tmp2=mpi_wait(req2);

assert(tmp1==tmp2);

fprintf(stderr,"mpi_irecv,mpi_test,mpi_wait\t:pass check\n");

#############
#mpi_testany#
#############
tag1=1;
tag2=2;
req1=mpi_irecv(sizeof,src,tag1,MPI_COMM_WORLD);
req2=mpi_irecv(sizeof,src,tag2,MPI_COMM_WORLD);
mpi_send(sizeof(tmp1),sizeof,dest,tag2,MPI_COMM_WORLD);

[flag idx val] = mpi_testany([req1 req2]);

assert((flag==1) && (idx==2) && (val==sizeof(tmp1)));

[flag idx val] = mpi_testany([req2 req1]);
assert((flag==-1) && (idx==-1));

mpi_send(sizeof(tmp1),sizeof,dest,tag1,MPI_COMM_WORLD);
[flag idx val]=mpi_testany(req1);

assert(val==sizeof(tmp1));
 
assert(mpi_wait(req1)=="error in mpi-module");

fprintf(stderr,"mpi_testany\t\t\t:pass check\n");

#############
#mpi_waitany#
#############
tag1=1;
tag2=2;
req1=mpi_irecv(sizeof,src,tag1,MPI_COMM_WORLD);
req2=mpi_irecv(sizeof,src,tag2,MPI_COMM_WORLD);
mpi_send(sizeof(tmp1),sizeof,dest,tag2,MPI_COMM_WORLD);

[flag idx val] = mpi_waitany([req1 req2]);

assert((flag==1) && (idx==2) && (val==sizeof(tmp1)));

[flag idx val] = mpi_waitany([req2 req1]);
assert((flag==-1) && (idx==-1));

mpi_send(sizeof(tmp1),sizeof,dest,tag1,MPI_COMM_WORLD);
[flag idx val]=mpi_waitany(req1);

assert(val==sizeof(tmp1));
 
assert(mpi_wait(req1)=="error in mpi-module");

fprintf(stderr,"mpi_waitany\t\t\t:pass check\n");


#############
#mpi_testall#
#############
tag1=1;
tag2=2;
req1=mpi_irecv(sizeof,src,tag1,MPI_COMM_WORLD);
req2=mpi_irecv(sizeof,src,tag2,MPI_COMM_WORLD);

[flag val1 val2] = mpi_testall([req1 req2]);
assert((flag==-2) && (val1== 0) && (val2==0));

mpi_send(sizeof(tmp1),sizeof,dest,tag2,MPI_COMM_WORLD);

[flag val1 val2] = mpi_testall([req1 req2]);
assert((flag==-2) && (val1== 0) && (val2==0));

mpi_send(sizeof(tmp1),sizeof,dest,tag1,MPI_COMM_WORLD);

[flag val1 val2] = mpi_testall([req1 req2]);
assert((flag==1) && (val1 == sizeof(tmp1)) && (val2 ==sizeof(tmp1)));
 
assert(mpi_wait(req1)=="error in mpi-module");

fprintf(stderr,"mpi_testall\t\t\t:pass check\n");

#############
#mpi_waitall#
#############
tag1=1;
tag2=2;
tag3=3;
tmp2=rand(5,10);
tmp3=rand(10,10);

req1=mpi_irecv(sizeof,src,tag1,MPI_COMM_WORLD);
req2=mpi_irecv(sizeof,src,tag2,MPI_COMM_WORLD);
req3=mpi_irecv(sizeof,src,tag3,MPI_COMM_WORLD);

mpi_send(sizeof(tmp2),sizeof,dest,tag2,MPI_COMM_WORLD);
mpi_send(sizeof(tmp3),sizeof,dest,tag3,MPI_COMM_WORLD);
mpi_send(sizeof(tmp1),sizeof,dest,tag1,MPI_COMM_WORLD);


[flag val1 val2 val3] = mpi_waitall([req1 req2 req3]);

assert(flag == 1);
assert(val1 == sizeof(tmp1))
assert(val2 == sizeof(tmp2));
assert(val3 == sizeof(tmp3));
 
assert(mpi_wait(req1)=="error in mpi-module");

fprintf(stderr,"mpi_waitall\t\t\t:pass check\n");

############
#mpi_cancel#
############
tag1=1;
req1=mpi_irecv(sizeof,src,tag1,MPI_COMM_WORLD);
assert(mpi_cancel(req1) == true);
assert(mpi_cancel(req1) == false);
assert(mpi_wait(req1) == "error in mpi-module");

fprintf(stderr,"mpi_cancel\t\t\t:pass check\n");
mpi_finalize();



