#include <mpi.h>
#include <assert.h>

#include "data_conv_map.h"

int main(int argc,char *argv[]){
  MPI_Init(&argc,&argv);

  MPI_Comm c1,c2;
  MPI_Comm *c1p,c2p;
  int k1=1;
  int k2=2;

  data_conv_map<int,MPI_Comm *> comm_map;

  std::pair<std::map<int,MPI_Comm *>::iterator,bool> ret;

  ret=comm_map.insert(std::make_pair(k1,&c1));
  assert(ret.second==true);
  ret=comm_map.insert(std::make_pair(k2,&c2));
  assert(ret.second==true);

  data_conv_map<int,MPI_Comm *>::iterator it;
  
  it=comm_map.find(k1);
  assert(it->second==&c1);
  it=comm_map.find(k2);
  assert(it->second==&c2);

  MPI_Finalize();
  return 0;
};
